[PATCH] kbuild: collect minimum tool versions into scripts/min-tool-version.sh

14 views
Skip to first unread message

Masahiro Yamada

unread,
Mar 11, 2021, 4:47:18 AM3/11/21
to linux-...@vger.kernel.org, Nicolas Pitre, Masahiro Yamada, Nathan Chancellor, Bernhard Rosenkränzer, Miguel Ojeda, Nick Desaulniers, Will Deacon, clang-bu...@googlegroups.com, linux-...@vger.kernel.org
The kernel build uses various tools, many of which are provided by the
same software suite, for example, LLVM and Binutils.

When you raise the minimum version of Clang/LLVM, you need to update
clang_min_version in scripts/cc-version.sh and also lld_min_version in
scripts/ld-version.sh.

Kbuild can handle CC=clang and LD=ld.lld independently, but it does not
make much sense to maintain their versions separately.

Let's make scripts/min-tool-version.sh a central place of minimum tool
versions so you do not need to touch multiple files.

This script prints the minimum version of the given tool.

$ scripts/min-tool-version.sh gcc
4.9.0
$ scripts/min-tool-version.sh llvm
10.0.1
$ scripts/min-tool-version.sh binutils
2.23.0
$ scripts/min-tool-version.sh foo
foo: unknown tool

Signed-off-by: Masahiro Yamada <masa...@kernel.org>
Reviewed-by: Nathan Chancellor <nat...@kernel.org>
---

scripts/cc-version.sh | 20 +++++---------------
scripts/ld-version.sh | 11 ++++-------
scripts/min-tool-version.sh | 27 +++++++++++++++++++++++++++
3 files changed, 36 insertions(+), 22 deletions(-)
create mode 100755 scripts/min-tool-version.sh

diff --git a/scripts/cc-version.sh b/scripts/cc-version.sh
index 3f2ee885b116..f1952c522466 100755
--- a/scripts/cc-version.sh
+++ b/scripts/cc-version.sh
@@ -6,18 +6,6 @@

set -e

-# When you raise the minimum compiler version, please update
-# Documentation/process/changes.rst as well.
-gcc_min_version=4.9.0
-clang_min_version=10.0.1
-icc_min_version=16.0.3 # temporary
-
-# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=63293
-# https://lore.kernel.org/r/2021010711...@shell.armlinux.org.uk
-if [ "$SRCARCH" = arm64 ]; then
- gcc_min_version=5.1.0
-fi
-
# Print the compiler name and some version components.
get_compiler_info()
{
@@ -48,18 +36,20 @@ set -- $(get_compiler_info "$@")

name=$1

+min_tool_version=$(dirname $0)/min-tool-version.sh
+
case "$name" in
GCC)
version=$2.$3.$4
- min_version=$gcc_min_version
+ min_version=$($min_tool_version gcc)
;;
Clang)
version=$2.$3.$4
- min_version=$clang_min_version
+ min_version=$($min_tool_version llvm)
;;
ICC)
version=$(($2 / 100)).$(($2 % 100)).$3
- min_version=$icc_min_version
+ min_version=$($min_tool_version icc)
;;
*)
echo "$orig_args: unknown compiler" >&2
diff --git a/scripts/ld-version.sh b/scripts/ld-version.sh
index 30debf78aa09..5b9481e98b4f 100755
--- a/scripts/ld-version.sh
+++ b/scripts/ld-version.sh
@@ -6,11 +6,6 @@

set -e

-# When you raise the minimum linker version, please update
-# Documentation/process/changes.rst as well.
-bfd_min_version=2.23.0
-lld_min_version=10.0.1
-
# Convert the version string x.y.z to a canonical 5 or 6-digit form.
get_canonical_version()
{
@@ -35,10 +30,12 @@ set -- $("$@" --version)
IFS=' '
set -- $1

+min_tool_version=$(dirname $0)/min-tool-version.sh
+
if [ "$1" = GNU -a "$2" = ld ]; then
shift $(($# - 1))
version=$1
- min_version=$bfd_min_version
+ min_version=$($min_tool_version binutils)
name=BFD
disp_name="GNU ld"
elif [ "$1" = GNU -a "$2" = gold ]; then
@@ -51,7 +48,7 @@ else

if [ "$1" = LLD ]; then
version=$2
- min_version=$lld_min_version
+ min_version=$($min_tool_version llvm)
name=LLD
disp_name=LLD
else
diff --git a/scripts/min-tool-version.sh b/scripts/min-tool-version.sh
new file mode 100755
index 000000000000..37c438d766d7
--- /dev/null
+++ b/scripts/min-tool-version.sh
@@ -0,0 +1,27 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0-only
+#
+# Print the minimum supported version of the given tool.
+
+set -e
+
+# When you raise the minimum version, please update
+# Documentation/process/changes.rst as well.
+min_gcc_version=4.9.0
+min_llvm_version=10.0.1
+min_icc_version=16.0.3 # temporary
+min_binutils_version=2.23.0
+
+# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=63293
+# https://lore.kernel.org/r/2021010711...@shell.armlinux.org.uk
+if [ "$SRCARCH" = arm64 ]; then
+ min_gcc_version=5.1.0
+fi
+
+eval min_version="\$min_${1}_version"
+if [ -z "$min_version" ]; then
+ echo "$1: unknown tool" >&2
+ exit 1
+fi
+
+echo "$min_version"
--
2.27.0

Miguel Ojeda

unread,
Mar 11, 2021, 5:18:21 AM3/11/21
to Masahiro Yamada, Linux Kbuild mailing list, Nicolas Pitre, Nathan Chancellor, Bernhard Rosenkränzer, Miguel Ojeda, Nick Desaulniers, Will Deacon, clang-built-linux, linux-kernel
On Thu, Mar 11, 2021 at 10:47 AM Masahiro Yamada <masa...@kernel.org> wrote:
>
> +# When you raise the minimum version, please update
> +# Documentation/process/changes.rst as well.
> +min_gcc_version=4.9.0
> +min_llvm_version=10.0.1
> +min_icc_version=16.0.3 # temporary
> +min_binutils_version=2.23.0

+1 to creating a central place for all minimum versions.

Acked-by: Miguel Ojeda <oj...@kernel.org>

I wonder if you considered creating a folder with files like
`scripts/min_versions/gcc` containing the version string. That would
make it easier for reading from other languages or even importing them
dynamically into the documentation, thus removing even more
duplication.

Cheers,
Miguel

Masahiro Yamada

unread,
Mar 11, 2021, 5:34:46 AM3/11/21
to Miguel Ojeda, Linux Kbuild mailing list, Nicolas Pitre, Nathan Chancellor, Bernhard Rosenkränzer, Miguel Ojeda, Nick Desaulniers, Will Deacon, clang-built-linux, linux-kernel
Hmm, that is a simple, clean idea.
Then, we can simply read out the file

$ cat scripts/min_versions/gcc
4.9.0

I do not know how to handle
per-arch versions in this case.




Or, we might need to stick to shell-scripting
to handle this.

scripts/min_versions/gcc
#!/bin/sh
# SPDX-License-Identifier: GPL-2.0-only
if [ "$SRCARCH" = arm64 ]; then
echo 5.1.0
else
echo 4.9.0
fi


--
Best Regards
Masahiro Yamada

Miguel Ojeda

unread,
Mar 11, 2021, 6:15:46 AM3/11/21
to Masahiro Yamada, Linux Kbuild mailing list, Nicolas Pitre, Nathan Chancellor, Bernhard Rosenkränzer, Miguel Ojeda, Nick Desaulniers, Will Deacon, clang-built-linux, linux-kernel
On Thu, Mar 11, 2021 at 11:34 AM Masahiro Yamada <masa...@kernel.org> wrote:
>
> Hmm, that is a simple, clean idea.
> Then, we can simply read out the file
>
> $ cat scripts/min_versions/gcc
> 4.9.0

Exactly!

> I do not know how to handle
> per-arch versions in this case.

Perhaps we should just push for 5.1.0 everywhere ;-P

Otherwise, we could still have `min-tool-versions.sh` with something like:

$ cat scripts/min_versions/gcc
4.9.0
$ cat scripts/min_versions/gcc_arm64
5.1.0
$ cat scripts/min-tool-versions.sh
if min_versions/$tool_$arch exists
print that one
else
print the default one: min_versions/$tool

i.e. having the plain files allow us to extend the cases without
listing them explicitly in the script, plus it is anyway useful to
separate data from code :-)

Cheers,
Miguel

Nicolas Pitre

unread,
Mar 11, 2021, 8:19:28 PM3/11/21
to Miguel Ojeda, Masahiro Yamada, Linux Kbuild mailing list, Nathan Chancellor, Bernhard Rosenkränzer, Miguel Ojeda, Nick Desaulniers, Will Deacon, clang-built-linux, linux-kernel
Alternatively, the documentation could be the actual reference and the
script would parse the documentation to get those values out.


Nicolas

Sedat Dilek

unread,
Mar 12, 2021, 6:10:42 AM3/12/21
to Masahiro Yamada, linux-...@vger.kernel.org, Nicolas Pitre, Nathan Chancellor, Bernhard Rosenkränzer, Miguel Ojeda, Nick Desaulniers, Will Deacon, Clang-Built-Linux ML, linux-...@vger.kernel.org
On Thu, Mar 11, 2021 at 10:47 AM Masahiro Yamada <masa...@kernel.org> wrote:
>
> The kernel build uses various tools, many of which are provided by the
> same software suite, for example, LLVM and Binutils.
>
> When you raise the minimum version of Clang/LLVM, you need to update
> clang_min_version in scripts/cc-version.sh and also lld_min_version in
> scripts/ld-version.sh.
>
> Kbuild can handle CC=clang and LD=ld.lld independently, but it does not
> make much sense to maintain their versions separately.
>
> Let's make scripts/min-tool-version.sh a central place of minimum tool
> versions so you do not need to touch multiple files.
>
> This script prints the minimum version of the given tool.
>
> $ scripts/min-tool-version.sh gcc
> 4.9.0
> $ scripts/min-tool-version.sh llvm
> 10.0.1
> $ scripts/min-tool-version.sh binutils
> 2.23.0
> $ scripts/min-tool-version.sh foo
> foo: unknown tool
>
> Signed-off-by: Masahiro Yamada <masa...@kernel.org>
> Reviewed-by: Nathan Chancellor <nat...@kernel.org>

The idea with creating gcc, llvm, binutils etc. files containing the
minimum version-string sounds good to me.

This version here tested on Debian/testing AMD64.

Tested-by: Sedat Dilek <sedat...@gmail.com> # LLVM/Clang v12.0.0-rc3

- Sedat -
> --
> You received this message because you are subscribed to the Google Groups "Clang Built Linux" group.
> To unsubscribe from this group and stop receiving emails from it, send an email to clang-built-li...@googlegroups.com.
> To view this discussion on the web visit https://groups.google.com/d/msgid/clang-built-linux/20210311094624.923913-1-masahiroy%40kernel.org.

Masahiro Yamada

unread,
Mar 15, 2021, 12:14:05 PM3/15/21
to linux-...@vger.kernel.org, Masahiro Yamada, Nathan Chancellor, Miguel Ojeda, Sedat Dilek, Bernhard Rosenkränzer, Nick Desaulniers, Thomas Bogendoerfer, Will Deacon, clang-bu...@googlegroups.com, linux-...@vger.kernel.org
The kernel build uses various tools, many of which are provided by the
same software suite, for example, LLVM and Binutils.

When you raise the minimum version of Clang/LLVM, you need to update
clang_min_version in scripts/cc-version.sh and also lld_min_version in
scripts/ld-version.sh.

Kbuild can handle CC=clang and LD=ld.lld independently, but it does not
make much sense to maintain their versions separately.

Let's create a central place of minimum tool versions so you do not need
to touch multiple files. scripts/min-tool-version.sh prints the minimum
version of the given tool.

Signed-off-by: Masahiro Yamada <masa...@kernel.org>
Reviewed-by: Nathan Chancellor <nat...@kernel.org>
Acked-by: Miguel Ojeda <oj...@kernel.org>
Tested-by: Sedat Dilek <sedat...@gmail.com>
---

Changes in v2:
- Use case ... esac

scripts/cc-version.sh | 20 +++++--------------
scripts/ld-version.sh | 11 ++++-------
scripts/min-tool-version.sh | 39 +++++++++++++++++++++++++++++++++++++
3 files changed, 48 insertions(+), 22 deletions(-)
index 1bf3aadde9de..a78b804b680c 100755
--- a/scripts/ld-version.sh
+++ b/scripts/ld-version.sh
@@ -6,11 +6,6 @@

set -e

-# When you raise the minimum linker version, please update
-# Documentation/process/changes.rst as well.
-bfd_min_version=2.23.0
-lld_min_version=10.0.1
-
# Convert the version string x.y.z to a canonical 5 or 6-digit form.
get_canonical_version()
{
@@ -35,10 +30,12 @@ set -- $(LC_ALL=C "$@" --version)
IFS=' '
set -- $1

+min_tool_version=$(dirname $0)/min-tool-version.sh
+
if [ "$1" = GNU -a "$2" = ld ]; then
shift $(($# - 1))
version=$1
- min_version=$bfd_min_version
+ min_version=$($min_tool_version binutils)
name=BFD
disp_name="GNU ld"
elif [ "$1" = GNU -a "$2" = gold ]; then
@@ -51,7 +48,7 @@ else

if [ "$1" = LLD ]; then
version=$2
- min_version=$lld_min_version
+ min_version=$($min_tool_version llvm)
name=LLD
disp_name=LLD
else
diff --git a/scripts/min-tool-version.sh b/scripts/min-tool-version.sh
new file mode 100755
index 000000000000..d22cf91212b0
--- /dev/null
+++ b/scripts/min-tool-version.sh
@@ -0,0 +1,39 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0-only
+#
+# Print the minimum supported version of the given tool.
+# When you raise the minimum version, please update
+# Documentation/process/changes.rst as well.
+
+set -e
+
+if [ $# != 1 ]; then
+ echo "Usage: $0 toolname" >&2
+ exit 1
+fi
+
+case "$1" in
+binutils)
+ echo 2.23.0
+ ;;
+gcc)
+ # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=63293
+ # https://lore.kernel.org/r/2021010711...@shell.armlinux.org.uk
+ if [ "$SRCARCH" = arm64 ]; then
+ echo 5.1.0
+ else
+ echo 4.9.0
+ fi
+ ;;
+icc)
+ # temporary
+ echo 16.0.3
+ ;;
+llvm)
+ echo 10.0.1
+ ;;
+*)
+ echo "$1: unknown tool" >&2
+ exit 1
+ ;;
+esac
--
2.27.0

Masahiro Yamada

unread,
Mar 15, 2021, 12:14:37 PM3/15/21
to linux-...@vger.kernel.org, Masahiro Yamada, Andrew Morton, Christian Brauner, Colin Ian King, David Howells, Frederic Weisbecker, Johannes Weiner, KP Singh, Kees Cook, Michal Marek, Nathan Chancellor, Nick Desaulniers, Nick Terrell, Peter Zijlstra, Sami Tolvanen, Stephen Boyd, Steven Rostedt (VMware), Thomas Gleixner, Valentin Schneider, Viresh Kumar, Vlastimil Babka, YiFei Zhu, clang-bu...@googlegroups.com, linux-...@vger.kernel.org
Documentation/process/changes.rst defines the minimum assembler version
(binutils version), but we have never checked it in the build time.

Kbuild never invokes 'as' directly because all assembly files in the
kernel tree are *.S, hence must be preprocessed. I do not expect
raw assembly source files (*.s) would be added to the kernel tree.

Therefore, we always use $(CC) as the assembler driver, and commit
aa824e0c962b ("kbuild: remove AS variable") removed 'AS'. However,
we are still interested in the version of the assembler acting behind.

As usual, the --version option prints the version string.

$ as --version | head -n 1
GNU assembler (GNU Binutils for Ubuntu) 2.35.1

But, we do not have $(AS). So, we can add the -Wa prefix so that
$(CC) passes --version down to the backing assembler.

$ gcc -Wa,--version | head -n 1
gcc: fatal error: no input files
compilation terminated.

OK, we need to input something to satisfy gcc.

$ gcc -Wa,--version -c -x assembler /dev/null -o /dev/null | head -n 1
GNU assembler (GNU Binutils for Ubuntu) 2.35.1

The combination of Clang and GNU assembler works in the same way:

$ clang -no-integrated-as -Wa,--version -c -x assembler /dev/null -o /dev/null | head -n 1
GNU assembler (GNU Binutils for Ubuntu) 2.35.1

Clang with the integrated assembler fails like this:

$ clang -integrated-as -Wa,--version -c -x assembler /dev/null -o /dev/null | head -n 1
clang: error: unsupported argument '--version' to option 'Wa,'

For the last case, checking the error message is fragile. If the
proposal for -Wa,--version support [1] is accepted, this may not be
even an error in the future.

One easy way is to check if -integrated-as is present in the passed
arguments. We did not pass -integrated-as to CLANG_FLAGS before, but
we can make it explicit.

Nathan pointed out -integrated-as is the default for all of the
architectures/targets that the kernel cares about, but it goes
along with "explicit is better than implicit" policy. [2]

With all this in my mind, I implemented scripts/as-version.sh to
check the assembler version in Kconfig time.

$ scripts/as-version.sh gcc
GNU 23501
$ scripts/as-version.sh clang -no-integrated-as
GNU 23501
$ scripts/as-version.sh clang -integrated-as
LLVM 0

[1]: https://github.com/ClangBuiltLinux/linux/issues/1320
[2]: https://lore.kernel.org/linux-kbuild/20210307044253.v3h47ucq6ng25iay@archlinux-ax161/

Signed-off-by: Masahiro Yamada <masa...@kernel.org>
---

Changes in v2:
- Check -integrated-as option instead of error message.
- Add LC_ALL=C just in case.

The Italian locale did not tweak the message from 'as --version'
but we never know what would happen on locale.

$ LC_MESSAGES=it_IT.UTF-8 ld --version | head -n 1
ld di GNU (GNU Binutils for Debian) 2.35.2
$ LC_MESSAGES=it_IT.UTF-8 as --version | head -n 1
GNU assembler (GNU Binutils for Debian) 2.35.2

Makefile | 4 +-
arch/Kconfig | 3 +-
init/Kconfig | 12 ++++++
scripts/Kconfig.include | 6 +++
scripts/as-version.sh | 82 +++++++++++++++++++++++++++++++++++++++++
5 files changed, 104 insertions(+), 3 deletions(-)
create mode 100755 scripts/as-version.sh

diff --git a/Makefile b/Makefile
index cc5b7e39fde4..2b161f5a5a66 100644
--- a/Makefile
+++ b/Makefile
@@ -580,7 +580,9 @@ ifneq ($(findstring clang,$(CC_VERSION_TEXT)),)
ifneq ($(CROSS_COMPILE),)
CLANG_FLAGS += --target=$(notdir $(CROSS_COMPILE:%-=%))
endif
-ifneq ($(LLVM_IAS),1)
+ifeq ($(LLVM_IAS),1)
+CLANG_FLAGS += -integrated-as
+else
CLANG_FLAGS += -no-integrated-as
GCC_TOOLCHAIN_DIR := $(dir $(shell which $(CROSS_COMPILE)elfedit))
CLANG_FLAGS += --prefix=$(GCC_TOOLCHAIN_DIR)$(notdir $(CROSS_COMPILE))
diff --git a/arch/Kconfig b/arch/Kconfig
index ecfd3520b676..555b4f09a9b2 100644
--- a/arch/Kconfig
+++ b/arch/Kconfig
@@ -631,8 +631,7 @@ config ARCH_SUPPORTS_LTO_CLANG_THIN
config HAS_LTO_CLANG
def_bool y
# Clang >= 11: https://github.com/ClangBuiltLinux/linux/issues/510
- depends on CC_IS_CLANG && CLANG_VERSION >= 110000 && LD_IS_LLD
- depends on $(success,test $(LLVM_IAS) -eq 1)
+ depends on CC_IS_CLANG && CLANG_VERSION >= 110000 && LD_IS_LLD && AS_IS_LLVM
depends on $(success,$(NM) --help | head -n 1 | grep -qi llvm)
depends on $(success,$(AR) --help | head -n 1 | grep -qi llvm)
depends on ARCH_SUPPORTS_LTO_CLANG
diff --git a/init/Kconfig b/init/Kconfig
index 5f5c776ef192..019c1874e609 100644
--- a/init/Kconfig
+++ b/init/Kconfig
@@ -41,6 +41,18 @@ config CLANG_VERSION
default $(cc-version) if CC_IS_CLANG
default 0

+config AS_IS_GNU
+ def_bool $(success,test "$(as-name)" = GNU)
+
+config AS_IS_LLVM
+ def_bool $(success,test "$(as-name)" = LLVM)
+
+config AS_VERSION
+ int
+ # Use clang version if this is the integrated assembler
+ default CLANG_VERSION if AS_IS_LLVM
+ default $(as-version)
+
config LD_IS_BFD
def_bool $(success,test "$(ld-name)" = BFD)

diff --git a/scripts/Kconfig.include b/scripts/Kconfig.include
index 58fdb5308725..0496efd6e117 100644
--- a/scripts/Kconfig.include
+++ b/scripts/Kconfig.include
@@ -45,6 +45,12 @@ $(error-if,$(success,test -z "$(cc-info)"),Sorry$(comma) this compiler is not su
cc-name := $(shell,set -- $(cc-info) && echo $1)
cc-version := $(shell,set -- $(cc-info) && echo $2)

+# Get the assembler name, version, and error out if it is not supported.
+as-info := $(shell,$(srctree)/scripts/as-version.sh $(CC) $(CLANG_FLAGS))
+$(error-if,$(success,test -z "$(as-info)"),Sorry$(comma) this assembler is not supported.)
+as-name := $(shell,set -- $(as-info) && echo $1)
+as-version := $(shell,set -- $(as-info) && echo $2)
+
# Get the linker name, version, and error out if it is not supported.
ld-info := $(shell,$(srctree)/scripts/ld-version.sh $(LD))
$(error-if,$(success,test -z "$(ld-info)"),Sorry$(comma) this linker is not supported.)
diff --git a/scripts/as-version.sh b/scripts/as-version.sh
new file mode 100755
index 000000000000..953ff000bcbc
--- /dev/null
+++ b/scripts/as-version.sh
@@ -0,0 +1,82 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0-only
+#
+# Print the assembler name and its version in a 5 or 6-digit form.
+# Also, perform the minimum version check.
+# (If it is the integrated assembler, return 0 as the version, and
+# skip the version check.)
+
+set -e
+
+# Convert the version string x.y.z to a canonical 5 or 6-digit form.
+get_canonical_version()
+{
+ IFS=.
+ set -- $1
+
+ # If the 2nd or 3rd field is missing, fill it with a zero.
+ #
+ # The 4th field, if present, is ignored.
+ # This occurs in development snapshots as in 2.35.1.20201116
+ echo $((10000 * $1 + 100 * ${2:-0} + ${3:-0}))
+}
+
+# Clang failes to handle -Wa,--version fails unless -no-integrated-as is given.
+# We check -(f)integrated-as, expecting it is explicitly passed in for the
+# integrated assembler case.
+check_integrated_as()
+{
+ while [ $# -gt 0 ]; do
+ if [ "$1" = -integrated-as -o "$1" = -fintegrated-as ]; then
+ # For the intergrated assembler, we do not check the
+ # version here. It is the same as the clang version, and
+ # it has been already checked by scripts/cc-version.sh.
+ echo LLVM 0
+ exit 0
+ fi
+ shift
+ done
+}
+
+check_integrated_as "$@"
+
+orig_args="$@"
+
+# Get the first line of the --version output.
+IFS='
+'
+set -- $(LC_ALL=C "$@" -Wa,--version -c -x assembler /dev/null -o /dev/null 2>&1)
+
+# Split the line on spaces.
+IFS=' '
+set -- $1
+
+min_tool_version=$(dirname $0)/min-tool-version.sh
+
+if [ "$1" = GNU -a "$2" = assembler ]; then
+ shift $(($# - 1))
+ version=$1
+ min_version=$($min_tool_version binutils)
+ name=GNU
+else
+ echo "$orig_args: unknown assembler invoked" >&2
+ exit 1
+fi
+
+# Some distributions append a package release number, as in 2.34-4.fc32
+# Trim the hyphen and any characters that follow.
+version=${version%-*}
+
+cversion=$(get_canonical_version $version)
+min_cversion=$(get_canonical_version $min_version)
+
+if [ "$cversion" -lt "$min_cversion" ]; then
+ echo >&2 "***"
+ echo >&2 "*** Assembler is too old."
+ echo >&2 "*** Your $name assembler version: $version"
+ echo >&2 "*** Minimum $name assembler version: $min_version"
+ echo >&2 "***"
+ exit 1
+fi
+
+echo $name $cversion
--
2.27.0

Masahiro Yamada

unread,
Mar 15, 2021, 12:14:42 PM3/15/21
to linux-...@vger.kernel.org, Masahiro Yamada, Nathan Chancellor, Andrew Morton, Andy Shevchenko, Nick Desaulniers, Peter Enderborg, Sedat Dilek, Thomas Gleixner, Vitor Massaru Iha, Wei Yang, clang-bu...@googlegroups.com, linux-...@vger.kernel.org, pet...@infradead.org
The test code in scripts/test_dwarf5_support.sh is somewhat difficult
to understand, but after all, we want to check binutils >= 2.35.2

From the former discussion, the requirement for generating DWARF v5 from
C code is as follows:

- gcc + gnu as -> requires gcc 5.0+ (but 7.0+ for full support)
- clang + gnu as -> requires binutils 2.35.2+
- clang + integrated as -> OK

Signed-off-by: Masahiro Yamada <masa...@kernel.org>
Reviewed-by: Nathan Chancellor <nat...@kernel.org>
---

Changes in v2:
- fix typos
- simplify the dependency expression

lib/Kconfig.debug | 3 +--
scripts/test_dwarf5_support.sh | 8 --------
2 files changed, 1 insertion(+), 10 deletions(-)
delete mode 100755 scripts/test_dwarf5_support.sh

diff --git a/lib/Kconfig.debug b/lib/Kconfig.debug
index b479ae609a31..c85d5f7a1aeb 100644
--- a/lib/Kconfig.debug
+++ b/lib/Kconfig.debug
@@ -284,8 +284,7 @@ config DEBUG_INFO_DWARF4

config DEBUG_INFO_DWARF5
bool "Generate DWARF Version 5 debuginfo"
- depends on GCC_VERSION >= 50000 || CC_IS_CLANG
- depends on CC_IS_GCC || $(success,$(srctree)/scripts/test_dwarf5_support.sh $(CC) $(CLANG_FLAGS))
+ depends on GCC_VERSION >= 50000 || (CC_IS_CLANG && (AS_IS_LLVM || (AS_IS_GNU && AS_VERSION >= 23502)))
depends on !DEBUG_INFO_BTF
help
Generate DWARF v5 debug info. Requires binutils 2.35.2, gcc 5.0+ (gcc
diff --git a/scripts/test_dwarf5_support.sh b/scripts/test_dwarf5_support.sh
deleted file mode 100755
index c46e2456b47a..000000000000
--- a/scripts/test_dwarf5_support.sh
+++ /dev/null
@@ -1,8 +0,0 @@
-#!/bin/sh
-# SPDX-License-Identifier: GPL-2.0
-
-# Test that the assembler doesn't need -Wa,-gdwarf-5 when presented with DWARF
-# v5 input, such as `.file 0` and `md5 0x00`. Should be fixed in GNU binutils
-# 2.35.2. https://sourceware.org/bugzilla/show_bug.cgi?id=25611
-echo '.file 0 "filename" md5 0x7a0b65214090b6693bd1dc24dd248245' | \
- $* -gdwarf-5 -Wno-unused-command-line-argument -c -x assembler -o /dev/null -
--
2.27.0

Nick Desaulniers

unread,
Mar 15, 2021, 12:46:36 PM3/15/21
to Masahiro Yamada, Linux Kbuild mailing list, Nathan Chancellor, Andrew Morton, Andy Shevchenko, Peter Enderborg, Sedat Dilek, Thomas Gleixner, Vitor Massaru Iha, Wei Yang, clang-built-linux, LKML, pet...@infradead.org
On Mon, Mar 15, 2021 at 9:13 AM Masahiro Yamada <masa...@kernel.org> wrote:
>
> The test code in scripts/test_dwarf5_support.sh is somewhat difficult
> to understand, but after all, we want to check binutils >= 2.35.2
>
> From the former discussion, the requirement for generating DWARF v5 from
> C code is as follows:
>
> - gcc + gnu as -> requires gcc 5.0+ (but 7.0+ for full support)
> - clang + gnu as -> requires binutils 2.35.2+
> - clang + integrated as -> OK
>
> Signed-off-by: Masahiro Yamada <masa...@kernel.org>
> Reviewed-by: Nathan Chancellor <nat...@kernel.org>

Reviewed-by: Nick Desaulniers <ndesau...@google.com>
--
Thanks,
~Nick Desaulniers
--
Thanks,
~Nick Desaulniers

Nathan Chancellor

unread,
Mar 15, 2021, 1:34:33 PM3/15/21
to Masahiro Yamada, linux-...@vger.kernel.org, Andrew Morton, Christian Brauner, Colin Ian King, David Howells, Frederic Weisbecker, Johannes Weiner, KP Singh, Kees Cook, Michal Marek, Nick Desaulniers, Nick Terrell, Peter Zijlstra, Sami Tolvanen, Stephen Boyd, Steven Rostedt (VMware), Thomas Gleixner, Valentin Schneider, Viresh Kumar, Vlastimil Babka, YiFei Zhu, clang-bu...@googlegroups.com, linux-...@vger.kernel.org
Reviewed-by: Nathan Chancellor <nat...@kernel.org>

Masahiro Yamada

unread,
Mar 16, 2021, 3:14:07 AM3/16/21
to Linux Kbuild mailing list, Andrew Morton, Christian Brauner, Colin Ian King, David Howells, Frederic Weisbecker, Johannes Weiner, KP Singh, Kees Cook, Michal Marek, Nathan Chancellor, Nick Desaulniers, Nick Terrell, Peter Zijlstra, Sami Tolvanen, Stephen Boyd, Steven Rostedt (VMware), Thomas Gleixner, Valentin Schneider, Viresh Kumar, Vlastimil Babka, YiFei Zhu, clang-built-linux, Linux Kernel Mailing List
This line got strange after some editing.

I will rephrase it to:

Clang fails to handle -Wa,--version unless -no-integrated-as is given.
> --
> You received this message because you are subscribed to the Google Groups "Clang Built Linux" group.
> To unsubscribe from this group and stop receiving emails from it, send an email to clang-built-li...@googlegroups.com.
> To view this discussion on the web visit https://groups.google.com/d/msgid/clang-built-linux/20210315161257.788477-2-masahiroy%40kernel.org.

Nick Desaulniers

unread,
Mar 31, 2021, 7:41:56 PM3/31/21
to Masahiro Yamada, Linux Kbuild mailing list, Andrew Morton, Christian Brauner, Colin Ian King, David Howells, Frederic Weisbecker, Johannes Weiner, KP Singh, Kees Cook, Michal Marek, Nathan Chancellor, Nick Terrell, Peter Zijlstra, Sami Tolvanen, Stephen Boyd, Steven Rostedt (VMware), Thomas Gleixner, Valentin Schneider, Viresh Kumar, Vlastimil Babka, YiFei Zhu, clang-built-linux, Linux Kernel Mailing List, Jian Cai
Jian just landed support for this, it will ship in clang-13:
https://reviews.llvm.org/rG3cc3c0f8352ec33ca2f2636f94cb1d85fc57ac16
https://github.com/ClangBuiltLinux/linux/issues/1320
Thanks Jian!
--
Thanks,
~Nick Desaulniers
Reply all
Reply to author
Forward
0 new messages